#include "GButton.h"

/*
  Initialize an empty button, no functionality
*/
GButton::GButton()
{
  drawFunc=NULL;
  init();
}
/*
  Initialize button
*/
GButton::GButton(GObject * parent,char * str,int x,int y,int width,int height)
{
  drawFunc=NULL;
  init(parent,str,x,y,width,height);
}

/*
  void GButton::draw()
  pre: none
  post: if the draw function has been set, it will be called,
        otherwise it will draw as a GObject.
*/
void GButton::draw()
{
  if(drawFunc){
    drawFunc(this);
  }
  else GObject::draw();
}

/*
  GRadioButton
  post: initalize a new radio button with a value of 0
*/  
GRadioButton::GRadioButton(GObject * parent,char * str,int x,int y,int width,int height)
{
value=0;
init(parent,str,x,y,width,height);
}

/*
  defaulAction
  post:The default action when clicking is to toggle the 
  value
*/
void GRadioButton::defaultAction(GObject *)
{
  value = !value;
}
/*
  Draw the button
*/
void GRadioButton::draw()
{
  if(state&G_DRAW_BACKGROUND)
    drawBackGround();
 
  if(getActive())
    glColor3f(1.0f,1.0f,1.0f);
  else
    glColor3f(0.3f,0.3f,0.3f);
  glBegin(GL_QUADS);
  glVertex2i(x+2,y+2);
  glVertex2i(x+2,y+TEXT_HEIGHT-2);
  glVertex2i(x+TEXT_HEIGHT-2,y+TEXT_HEIGHT-2);
  glVertex2i(x+TEXT_HEIGHT-2,y+2);
  glEnd();
  if(value && getActive()){
    glColor3f(0.0f,0.0f,0.0f);
    glBegin(GL_QUADS);
    glVertex2i(x+3,y+3);
    glVertex2i(x+3,y+TEXT_HEIGHT-3);
    glVertex2i(x+TEXT_HEIGHT-3,y+TEXT_HEIGHT-3);
    glVertex2i(x+TEXT_HEIGHT-3,y+3);
    glEnd();
  }
  
  if(getActive()){
    fgColor();
    glRasterPos2i(x+TEXT_HEIGHT,y+TEXT_HEIGHT);
    drawText(text);
  }
  else {
    glColor3f(0.3f,0.3f,0.3f);
    glRasterPos2i(x+TEXT_HEIGHT,y+TEXT_HEIGHT);
    drawText(text);
    
  }
}
