#ifndef G_COMBO_BOX
#define G_COMBO_BOX

#include "GObject.h"
#include "GList.h"

class GComboBox : public GObject
{
public:
  class GComboList : public GList{
  public:
    GComboList(){
      init();
    }
    GComboList(int flags,GObject * parent,int x,int y,int width,int height)
      : GList(flags,parent,x,y,width,height){
      
    }
    virtual int mouseReleased(int button,int x,int y){
      return GList::mouseReleased(button,x,y);
    }
    virtual int mousePressed(int button,int x,int y){
      return GList::mousePressed(button,x,y);
    }
    virtual int mouseDragged(int x,int y){
      GList::mouseDragged(x,y);
      return 0;
    }
    virtual int mouseMoved(int x,int y){
      //Don't wan the mouse moved to act like a mouse pressed
      //on the scroll bar, so handle it separately
      if(verticalScroll && verticalScroll->hit(x,y)){
	return verticalScroll->mouseMoved(x,y);
      }
      else return mousePressed(0,x,y);
    }
  };

  class GDownButton : public GButton{
  public:
    GDownButton(){
      init();
    }
    GDownButton(GObject * parent,int x,int y,int width,int height)
      :GButton(parent,"V",x,y,width,height){
    }
    virtual void draw(){
      drawBackGround();
      fgColor();
      glBegin(GL_TRIANGLES);
      glVertex2i(x,y+2);
      glVertex2i(x+width,y+2);
      glVertex2i(x+width/2,y+height-2);
      glEnd();
    }
  };
 public:
  GComboBox();
  GComboBox(int flags,GObject * parent,int x,int y,int width,int height);
  GComboBox(int flags,GObject * parent,int x,int y,int width,int thisHeight,int listHeight);
  virtual ~GComboBox();
  virtual void release();
  virtual void draw();
  
  virtual void defaultAction(GObject * go);

  void setSelected(int i);
  int  getSelected();
  int getNumElements();
  char * getSelectedElement();

  virtual int mousePressed(int button,int x,int y);
  virtual int mouseReleased(int button,int x,int y);
  virtual int mouseMoved(int x,int y);
  virtual int mouseDragged(int x,int y);

  
  void removeAllElements();
  void addElement(char * str);
  virtual void bgColor();

 protected:
	GDownButton * button;
	GComboList * list;
};

#endif
