#include "GFileFilter.h"
#include "GObject.h"
#include <sys/stat.h>
#include <dirent.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>


GFileFilter::GFileFilter()
{
  name=(char *)malloc(strlen("All Files *.*"));
  sprintf(name,"All Files *.*");
  accept = GFileFilter::acceptAll;
}

GFileFilter::GFileFilter(char * str, int (*accept)(char *)){
  name = (char *)malloc(strlen(str)+1);
  sprintf(name,str);
  if(accept){
    this->accept=accept;
  }
  else accept = GFileFilter::acceptAll;
}

GFileFilter::~GFileFilter(){
  release();
}

void GFileFilter::release(){
  if(name){
    free(name);
  }
  name=NULL;
}

char * GFileFilter::getName()
{
  return name;
}

int GFileFilter::acceptAll(char * filename)
{
  return 1;
}

int GFileFilterDemoDir::acceptDemoDirs(char * filename)
{
  
  DIR * dir = opendir(filename);
  char path[255];
  struct dirent * de;
  
  if(!dir){
    if(strstr(filename,".gz") || strstr(filename,".iff"))
      return 1;
    return 0;
  }
  de = readdir(dir);
  while(de){
    if(strstr(de->d_name,"data")){
      sprintf(path,"%s%c%s",filename,
	      DIR_SEPARATOR,de->d_name);
      struct stat buf;
      if(stat(path,&buf)>=0){
	if(S_ISDIR(buf.st_mode)){
	  closedir(dir);
	  return 1;
	}
      }
    }
    de =readdir(dir);
  }
  closedir(dir);
  return 0;
}
