#ifndef G_LIST_H
#define G_LIST_H

#include "GScrollable.h"
#include "GScrollBar.h"

#define GLIST_MAX_ELEMENTS 64


class GList : public GScrollable
{
protected:
	GScrollBar * verticalScroll;
	GScrollBar * horizontalScroll;

	int maxElements;
	int numElements;
	char ** elements;
	int top;
	int left;
	int selected;
	
public:
	GList();
	GList(int flags,GObject * parent,int x,int y,int width,int height);
	virtual ~GList();
	virtual void release();

	virtual void draw();
	virtual int mouseDragged(int x,int y);
	virtual int mousePressed(int button,int x,int y);
	virtual int mouseReleased(int button,int x,int y);

	void removeAllElements();
	void initElements();
	void addElement(char * str);
       
	virtual int getNumElements();
	virtual void  setSelected(int i);
	virtual int getSelected();
	virtual char * getSelectedElement();

	void setWidth(int width);

	int hitScrollBar(int x,int y);
	
	//Scrollable members
	virtual int getScrollAreaSize(GObject *);
	virtual int getScrollPosition(GObject *);
	virtual void scrollAction1(GObject *);
	virtual void scrollAction2(GObject *);
	virtual void scrollBarPressed(GObject *,int x,int y);

	void ( * doubleClickAction)(GObject *);
};
#endif

