#include "GProgressBar.h"

GProgressBar::GProgressBar()
{
  value=0;
  min=0;
  max=100;
}

GProgressBar::GProgressBar(GObject * parent,
			  int x,int y,
			  int width,int height,
			  int min,int max)
{
  init(parent,"",x,y,width,height);
  this->min=min;
  this->max=max;
}

void GProgressBar::setValue(int value)
{
  this->value=value;
  if(value<min)
    this->value=min;
  if(value>=max)
    this->value=max;
}

int GProgressBar::getValue()
{
  return value;
}

void GProgressBar::setMin(int m)
{
  min=m;
}

void GProgressBar::setMax(int max)
{
  this->max=max;
}

int GProgressBar::getMax()
{
  return max;
}
int GProgressBar::getMin()
{
  return min;
}

void GProgressBar::bgColor()
{
  glColor3f(1.0f,1.0f,1.0f);
}

void GProgressBar::fgColor()
{
  glColor3f(0.6f,0.6f,1.0f);
}

void GProgressBar::draw()
{
  int progressx;
  float progress;
  bgColor();
  glBegin(GL_QUADS);
   glVertex2i(x,y);
   glVertex2i(x+width,y);
   glVertex2i(x+width,y+height);
   glVertex2i(x,y+height);
  glEnd();
  
  fgColor();
  glBegin(GL_LINE_LOOP);
   glVertex2i(x,y);
   glVertex2i(x+width,y);
   glVertex2i(x+width,y+height);
   glVertex2i(x,y+height);
  glEnd();

  
  progress = ((float)(value-min))/((float)(max-min));
  progressx=(int)(progress*width);
  progressx+=x;
  glBegin(GL_QUADS);
   glVertex2i(x,y);
   glVertex2i(progressx,y);
   glVertex2i(progressx,y+height);
   glVertex2i(x,y+height);
  glEnd();

}
