#ifndef G_WINDOW_H
#define G_WINDOW_H

#include "GObject.h"
#include "GButton.h"

#define G_TITLEBAR 0x100
#define G_MOVEABLE 0x200
#define G_RESIZEABLE 0x400

class GWindow : public GObject
{
protected:
	GButton * closeButton;
	GObject ** objects;
	int numObjects;
	int maxObjects;
	int oldx,oldy;
	int moving;
	int resizing;
	int minWidth,minHeight;

	void initObjects();
public:
	GWindow();
	GWindow(GObject * parent,char * str,int x,int y,int width,int height);
	virtual void release();
	virtual ~GWindow();

	virtual void titleBarColor();
	virtual void drawTitleBar();
	virtual void draw();

	virtual int flipShade();

	virtual int keyTyped(unsigned int mod,char key);
	virtual int mousePressed(int button,int x,int y);
	virtual int mouseReleased(int button,int x,int y);
	virtual int mouseMoved(int x,int y);
	virtual int mouseDragged(int x,int y);

	void addObject(GObject * go);
	virtual void setShowing(int i);
	void increasePrecedence(int index);

	void destroyOnClose();
	GObject *  getCloseButton() 
	  {
	    return closeButton;
	  }
	virtual void fgColor(){glColor3f(1.0,1.0,1.0f);}
};
#endif
