#include "GWindows.h"
#include <GL/glut.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>

#include "GFileWindow.h"
#include "GWindow.h"
#include "GButton.h"
#include "GMenu.h"
#include "GList.h"
#include "GEditBox.h"
#include "GComboBox.h"
#include "GObject.h"
#include "GProgressBar.h"

int GFileWindow::numActive=0;

int gwx,gwy;
int moved=0;

extern int errno;

GObject ** objects;
int maxObjects=24;
int numObjects=0;

GList * gl;
GEditBox * ge;
GMenu * pm;

void clearText(GObject * gb)
{
  if(gb){
    ge->clearText();
  }
}

void addItem(GObject * go)
{
  gl->addElement("new String");
}

GObject * gwAddFileOpenWindow()
{
  GFileWindow * gfw =  new GFileWindow();
  gfw->setShowing(1);
  gwAddObject(gfw);
  return gfw;
}

void gwAddMessageBox(int flags,char * title,char * messagep)
{
  static int x=80;
  static int y=80;
  GStatic * stat;
  GButton * button;
  int sy=25;
  int len = strlen(messagep);
  char * message = new char[len+1];
  char cback;
  int start=0;
  int end=0;

  strcpy(message,messagep);

  GWindow * window= new GWindow(NULL,title,x,y,200,75);
  window->destroyOnClose();
  window->setShowing(1);

  end=getTextMaxSize(message,start,180);
  printf("Message : %s",message);
  while(end<len){
    cback=message[end];
    message[end]=0;
    stat = new GStatic(window,message+start,5,sy,180,TEXT_HEIGHT+2);
    message[end]=cback;
    window->addObject(stat);
    sy+=TEXT_HEIGHT+2;
    start=end;
    if(start>=len)
      break;
    end=getTextMaxSize(message,start,180);
  }
  stat = new GStatic(window,message+start,5,sy,180,TEXT_HEIGHT+6);
  window->addObject(stat);
  window->setHeight(sy+40);

  button = new GButton(window,"Close",80,sy+TEXT_HEIGHT+8,60,TEXT_HEIGHT+6);
  window->addObject(button);
  button->action = window->getCloseButton()->action;

  x+=25;
  y+=25;
  if(y>=250){
    x-=160;
    y=80;
  }

  printf("adding new message box\n");
  gwAddObject(window);
  gwIncreasePrecedencePointer(window);
  delete message;
}

void addWindow(GObject * go)
{
  char str[25];
  static int called=0;
  called++;
  sprintf(str,"window %d",called);
  gwAddObject(new GWindow(NULL,str,rand()%600,rand()%400,60,60));
  gwAddObject(pm);
}
void removePM(GObject  * go)
{
  if(go){
    gwRemoveObject(pm);
  }
}

void demo1()
{
  GMenuBar * gmb = new GMenuBar(NULL,0,0,640,20);
  GMenu * gm = new GMenu(MENU_VERTICAL,gmb,"File",0,0,30,10);
  GMenuItem * gmi = new GMenuItem(gm,"New",0,0,30,10);
  gmi->action = addWindow;
  gmb->addMenu(gm);
  gm->addMenuItem(gmi);
  gm->addMenuItem(new GMenuItem(gm,"Open",0,0,30,10));
  gm= new GMenu(MENU_VERTICAL,gmb,"Edit",0,0,30,10);
  gmb->addMenu(gm);
  gm->addMenuItem(new GMenuItem(gm,"Redo",0,0,30,10));
  gm->addMenuItem(new GMenuItem(gm,"Undo",0,0,30,10));

  gwAddObject(gmb);

	GWindow * go = new GWindow(NULL,"neil",0,20,100,200);
	GRadioButton * grb = new GRadioButton(NULL,"radio1",10,20,30,14);
	go->addObject(grb);
	grb = new GRadioButton(NULL,"radio2",10,36,30,14);
	go->addObject(grb);
	gwAddObject(go);

	gl = new GList(G_VERTICAL_SCROLL,go,10,75,50,75);
	gl->addElement("string 1");
	gl->addElement("string 2");
	gl->addElement("string 3");
	gl->addElement("string 4");
	gl->addElement("string 5");
	gl->addElement("string 6");
	gl->addElement("string 7");
	gl->addElement("string 8");
	gl->addElement("string 9");
	gl->addElement("string 10");
	GButton * gb = new GButton(go,"Add Item",10,165,45,12);
	gb->action = addItem;

	go->addObject(gl);
	go->addObject(gb);
	go->addObject(new GStatic(go,"Current Selected : ",10,180,80,12));
	go->addObject(new GGroupBox(go,"Group box",6,70,100,125));

	go = new GWindow(NULL,"new window",110,20,200,300);
	gb =new GButton(go,"button",10,20,60,14);
	gb->action = clearText;
	go->addObject(gb);
	ge = new GEditBox(G_VERTICAL_SCROLL,go,"",10,40,160,200);
	FILE * file = fopen("GEditBox.cpp","r");
	char buffer[256];
	while(fgets(buffer,255,file)!=NULL){
		ge->appendText(buffer);
	}
	go->addObject(ge);
	gwAddObject(go);
	//gwAddObject(new GRadioButton(NULL,"radio1",100,130,30,14));
	pm = new GMenu(MENU_VERTICAL | MENU_POPUP,NULL,"menu",100,100,40,15);
	pm->addMenuItem(new GMenuItem(gm,"",0,0,30,15));
	gmi=new GMenuItem(pm,"Menu Item",0,0,30,15);
	gmi->action = removePM;
	pm->addMenuItem(gmi);
}




void optionsWindow2(GObject * go)
{
  if(go){
  //gwoptionsWindow->setShowing(1);
    //menu->setShowing(0);
  }
}
void helpWindow2(GObject * go)
{
  if(go){
    //gwhelpWindow->setShowing(1);
    //menu->setShowing(0);
  }
}
void rbaction2(GObject * go)
{
  if(go){
    /*hardwarerb->setValue(0);
    softwarerb->setValue(0);
    ((GRadioButton *) go)->defaultAction(go);*/
  }
}

void opencallback2(int res,char * val)
{
  if(res &&val){
    printf("File open okayed %s\n",val);
  }
  else printf("File open canceled\n");
  if(val)
    delete val;
}

void openw2(GObject * go)
{
  if(go){
    GFileWindow * gfw =(GFileWindow *) gwAddFileOpenWindow();
    printf("opened new file window  numactive %d\n",GFileWindow::numActive);
    gfw->fileWindowCallback = opencallback2;
    gwAddMessageBox(0,"Hello","first message box");
    gwAddMessageBox(0,"Hello2","Second message box, with a really long message name, that is going to be causins some serious problems with the layout of the message box, namely that it is going to crash or it is going to be off the square of the message box");
  }
}

void fdemo()
{
  GWindow * gwoptionsWindow;
GWindow * gwhelpWindow;
GMenuItem * optionsmi;
GMenuItem * helpmi;
GMenuItem * exitmi;
GRadioButton *hardwarerb,*softwarerb;
GMenu * menu;

  menu = new GMenu(MENU_VERTICAL | MENU_POPUP,NULL,"Main Menu",100,100,40,15);
  optionsmi = new GMenuItem(menu,"Options",0,0,0,0);
  helpmi = new GMenuItem(menu,"Help",0,0,0,0);
  exitmi = new GMenuItem(menu,"Exit",0,0,0,0);
  
  optionsmi->action = optionsWindow2;
  helpmi->action = helpWindow2;
  exitmi->action=NULL;
  
  GMenuItem *newmi = new GMenuItem(menu,"New",0,0,0,0);
  newmi->action = openw2;

  gwAddObject(menu);
  menu->addMenuItem(new GMenuItem(menu,"",0,0,0,0));
  menu->addMenuItem(newmi);
  menu->addMenuItem(helpmi);
  menu->addMenuItem(optionsmi);
  
  gwoptionsWindow = new GWindow(NULL,"options",110,110,205,230);
  gwhelpWindow = new GWindow(NULL,"help",120,120,400,400);
  hardwarerb = new GRadioButton(gwoptionsWindow,"Hardware",10,40,40,15);
  hardwarerb->action = rbaction2;
  softwarerb = new GRadioButton(gwoptionsWindow,"Software",10,55,40,15);
  softwarerb->action = rbaction2;
	
  gwoptionsWindow->addObject(new GGroupBox(gwoptionsWindow,"Rendering Mode",5,25,80,100));
  gwoptionsWindow->addObject(hardwarerb);
  gwoptionsWindow->addObject(softwarerb);
  gwoptionsWindow->addObject(new GRadioButton(gwoptionsWindow,"MMX",30,70,40,15));
  gwoptionsWindow->addObject(new GGroupBox(gwoptionsWindow,"# of Basis",90,25,100,100));
  gwoptionsWindow->addObject(new GStatic(gwoptionsWindow,"Channel 1: ",95,40,40,15));
  gwoptionsWindow->addObject(new GStatic(gwoptionsWindow,"Channel 2: ",95,55,40,15));
  gwoptionsWindow->addObject(new GStatic(gwoptionsWindow,"Channel 3: ",95,70,40,15));
  gwoptionsWindow->addObject(new GStatic(gwoptionsWindow,"Channel 2: ",95,85,40,15));
  gwoptionsWindow->addObject(new GSpinEditBox(G_NUMBERSONLY,gwoptionsWindow,16,145,40,40,15));
  gwoptionsWindow->addObject(new GSpinEditBox(G_NUMBERSONLY,gwoptionsWindow,16,145,55,40,15));
  gwoptionsWindow->addObject(new GSpinEditBox(G_NUMBERSONLY,gwoptionsWindow,16,145,70,40,15));
  gwoptionsWindow->addObject(new GSpinEditBox(0,gwoptionsWindow,16,145,85,40,15));
  gwoptionsWindow->addObject(new GGroupBox(gwoptionsWindow,"Texture quality",5,130,190,50));
  
  gwAddObject(gwoptionsWindow);
  gwAddObject(gwhelpWindow);

  GProgressBar *  gpb = new GProgressBar(NULL,10,10,100,10,0,100);
  gwAddObject(gpb);
  gpb->setShowing(1);
  
  menu->setShowing(1);
  gwhelpWindow->setShowing(0);
  gwoptionsWindow->setShowing(0);
}


void gwInit()
{
  numObjects=0;
  objects = (GObject **) malloc(sizeof(GObject *)*maxObjects);
  memset(objects,0,sizeof(GObject *)*maxObjects);
	
  /*GComboBox * gcb = new GComboBox(G_VERTICAL_SCROLL,NULL,100,150,100,15,100);
    gcb->addElement("neil0");
    gcb->addElement("neil1");
    gcb->addElement("neil2");
    gcb->addElement("neil3");
    gcb->addElement("neil4");
    gcb->addElement("neil5");
    gcb->addElement("neil6");
    gcb->addElement("neil7");
    gcb->addElement("neil8");
    gcb->addElement("neil9");
    gcb->addElement("neil10");
    gcb->setShowing(1);
    gwAddObject(gcb);*/
  //	demo2();
  //gwAddFileOpenWindow();
}
/*
	pre: obj is not null
	post: remove the object from the array of objects
	      and delete it
*/
void gwRemoveObject(GObject * obj)
{
  int i=0;

  while(i<numObjects){
    if(objects[i]==obj){
      delete objects[i];
      objects[i]=NULL;
      i=i+1;
      while(i<numObjects){
	objects[i-1]=objects[i];
	i++;
      }
      numObjects--;
      break;
    }
    i++;
  }
}

/*
	pre: obj must be an objects allocated by new
	post: the object is added to the array of objects
*/
void gwAddObject(GObject * obj)
{
	
	if(numObjects<maxObjects){
		objects[numObjects]=obj;
		numObjects++;
	}
	//FIXME:
	else{
	}
}



int gwKeyTyped(unsigned int mod,char c)
{
  int i=0;
  while(i<numObjects){
    if(objects[i]->isShowing()){
      if(objects[i]->keyTyped(mod,c))
	return 1;
    }
    i++;
  }
  return 0;
}

int gwMouseMoved(int x,int y)
{
  int i=0;

  while(i<numObjects){
    if(objects[i]->isShowing()){
      objects[i]->mouseMoved(x,y);
    }
    i++;
  }
  return 1;
}

void gwIncreasePrecedencePointer(GObject * obj)
{
  int i=0;
  while(i<numObjects){
    if(objects[i]==obj){
      gwIncreasePrecedence(i);
      break;
    }
    i++;
  }
}

void gwIncreasePrecedence(int focusi)
{
  if(focusi>0 && focusi<numObjects){
    GObject * back = objects[0];
    objects[0]=objects[focusi];
    objects[focusi]=back;
  }
}

int gwMousePressed(int button,int x,int y)
{
  int i=0;
  int ret=0;
  
  while(i<numObjects){
    if(objects[i]->isShowing()){
      if(objects[i]->mousePressed(button,x,y)){
	gwIncreasePrecedence(i);
	ret=1;
	break;
      }
    }
    i++;
  }
  return ret;
}

int gwMouseReleased(int button,int x,int y)
{
  int i=0;

  while(i<numObjects){
    if(objects[i]->isShowing()){
      if(objects[i]->mouseReleased(button,x,y))
	return 1;
    }
    i++;  
  }
  return 0;
}

int gwMouseDragged(int x,int y)
{
  int i=0;

  while(i<numObjects){
    if(objects[i]->isShowing()){
      if(objects[i]->mouseDragged(x,y))
	return 1;
    }
    i++;  
  }
  return 0;
}

void gwDisplay(int width,int height)
{
  int vp[4];
  double pj[16];
  double mm[16];

  glGetIntegerv(GL_VIEWPORT,vp);
  glGetDoublev(GL_PROJECTION_MATRIX,pj);
  glGetDoublev(GL_MODELVIEW_MATRIX,mm);
  
  glViewport(0,0,width,height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0,width,height,0);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  int i=numObjects-1;
  while(i>=0){
    if(objects[i]->awaitingDestruction()){
      gwRemoveObject(objects[i]);
    }
    else if(objects[i]->isShowing()){
      objects[i]->draw();
    }
    i--;
  }
  glViewport(vp[0],vp[1],vp[2],vp[3]);
  glMatrixMode(GL_PROJECTION);
  glLoadMatrixd(pj);
  glMatrixMode(GL_MODELVIEW);
  glLoadMatrixd(mm);
}	


void gwShutdown()
{
  int i=0;
  while(i<numObjects){
    if(objects[i]){
      delete objects[i];
      objects[i]=NULL;
    }
    i++;
  }
  objects=NULL;
}

