// glutwindows.cpp : Defines the entry point for the console application.
//

#include "GWindows.h"

#include <GL/gl.h>
#include <GL/glut.h>

int window;
int width=640;
int height=480;

void fdemo();

void shutdown(int exitCode)
{
	glutDestroyWindow(window);
	gwShutdown();
	exit(exitCode);
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT);
	gwDisplay(width,height);
	glFinish();
	glutSwapBuffers();
}

void reshape(int x,int y)
{
	width=x;
	height=y;
}

void keyboard(unsigned char c,int x,int y)
{
	gwKeyTyped(glutGetModifiers(),c);
	if(c=='q' || c=='Q'){
		shutdown(0);
	}
}

void mouse(int button,int state,int x,int y)
{
	if(state==GLUT_DOWN)
		gwMousePressed(button,x,y);
	if(state==GLUT_UP)
		gwMouseReleased(button,x,y);
}

void motionFunc(int x, int y)
{
	gwMouseDragged(x,y);
}

void passiveMotionFunc(int x, int y)
{
	gwMouseMoved(x,y);
}

void redisplay(int time)
{
	glutPostRedisplay();
	glutTimerFunc(30,redisplay,0);
}

int main(int argc, char* argv[])
{
	gwInit();
	fdemo();

	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_RGBA|GLUT_DOUBLE);
	glutInitWindowSize(640,480);
	glutInitWindowPosition(10,10);
	
	window=glutCreateWindow("GlutWindows");
	glutDisplayFunc(display);
	glutKeyboardFunc(keyboard);
	glutMouseFunc(mouse);
	glutMotionFunc(motionFunc);
	glutPassiveMotionFunc(passiveMotionFunc);
	glutReshapeFunc(reshape);

	glutTimerFunc(30,redisplay,0);
	glutMainLoop();
	
	return 0;
}




