#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <sys/stat.h>
#include "mesh.h"
#include "useful.h"
#include <unistd.h>
int count=0;

int convertOBJ(FILE * fd,FILE * td)
{
  _3floats * vert;
  _2floats * tvert;
  _3floats * vnorm;
  _3ints  * poly,* tpoly;
  _3floats * pnorm;
  int nvert,ntvert,npoly;
  int i;
  char * line;
  char linebuf[1024];

  nvert = linecount(fd,"v ");
  ntvert = linecount(fd,"vt ");
  npoly  = linecount(fd,"f ");

  nvert=linecount(fd,"v ");
  ntvert=linecount(fd,"vt ");
  npoly=linecount(fd,"f ");

  vert=new _3floats[nvert];
  tvert=new _2floats[ntvert];
  vnorm=new float[nvert][3];
  poly=new _3ints[npoly];
  tpoly=new _3ints[npoly];
  pnorm=new float[npoly][3];

  for(i=0;i<nvert;i++)
  {
    line=nextline(fd,"v ");
    sscanf(line,"v %f %f %f",vert[i],vert[i]+1,vert[i]+2);
  }
  
  fseek(fd,0,SEEK_SET);
  
  for(i=0;i<ntvert;i++)
  {
    line=nextline(fd,"vt ");
    sscanf(line,"vt %f %f",tvert[i],tvert[i]+1);
  }

  fseek(fd,0,SEEK_SET);

  for(i=0;i<npoly;i++)
  {
    line=nextline(fd,"f ");
    sscanf(line,"f %d %d %d",poly[i],poly[i]+1,poly[i]+2);
    poly[i][0]--;
    poly[i][1]--;
    poly[i][2]--;
  }
  i=0;
  fprintf(td,"%d\n",nvert);
  while(i<nvert){
    fprintf(td,"%f %f %f\n",vert[i][0],vert[i][1],vert[i][2]);
    i++;
  }
  i=0;
  fprintf(td,"%d\n",ntvert);
  while(i<ntvert){
    fprintf(td,"%f %f\n",tvert[i][0],tvert[i][1]);
    i++;
  }
  i=0;
  fprintf(td,"%d\n",npoly);
  while(i<npoly){
    fprintf(td,"%d %d %d\n",poly[i][0],poly[i][1],poly[i][2]);
    i++;
  }
  int where=ftell(fd);
  fseek(fd,0,SEEK_SET);
  line = nextline(fd,"mean_x ");
  if(ftell(fd)<where)
    where=ftell(fd);
  fseek(fd,0,SEEK_SET);
  line = nextline(fd,"max_x ");
  if(ftell(fd)<where)
    where=ftell(fd);
  fseek(fd,0,SEEK_SET);
  line = nextline(fd,"min_x ");
  if(ftell(fd)<where)
    where=ftell(fd);
  fseek(fd,where,SEEK_SET);

  int c=fgetc(fd);
  if(c==10)
    c=getc(fd);
  while(c!=EOF){
    fputc(c,td);
    c=fgetc(fd);
  }
  return 1;
}

int main(int argc, char ** argv)
{
  DIR * dir;
  struct dirent * de;
  char * path;
  char * pathe;
  char * filename;
  char cwd[1024];
  char yuvofile[1024];
  char objectsToCat[1024];
  int i=0;

  if(argc<=1){
    printf("no input files\n");
    exit(1);
  }
  
  if(!(dir=opendir(argv[1]))){
    printf("error opening %s\n",argv[1]);
    exit(2);
  }
  sprintf(yuvofile,"%soutput.yuv",argv[1]);
  path = (char *)malloc(strlen(argv[1])+256);
  sprintf(path,"%s/",argv[1]);
  pathe = path+strlen(path);
	  
  printf("path is %s\n",path);
  count=0;
  de=readdir(dir);
  while(de){
    struct stat buf;
    sprintf(pathe,de->d_name);
    if(stat(path,&buf)>=0){
      if(S_ISDIR(buf.st_mode)
	 && (strstr(de->d_name,"data"))){
	count++;
      }
    }
    else printf("error stating %s\n",path);
    de=readdir(dir);
  }
  printf("num data directories is %d\n",count);
  FILE * header = fopen("header.convert","w");
  fprintf(header,"%d\n",count);
  fclose(header);

  getcwd(cwd,1024);

  rewinddir(dir);
  de=readdir(dir);
  i=0;
  /*
    Go through each directory and create a conglomerate file of the
    data
  */
  while(de){
    struct stat buf;
    FILE * ofile;
    chdir(cwd);
    sprintf(pathe,de->d_name);
    if(stat(path,&buf)>=0){
      if(S_ISDIR(buf.st_mode)
	 && (strstr(de->d_name,"data"))){
	char ofilename[64];
	char sfilename[64];
	chdir(path);
	sprintf(sfilename,"./geometry.obj");
	sprintf(ofilename,"geometry.conv",i);
	ofile = fopen(ofilename,"w");
	convertOBJ(fopen(sfilename,"r"),ofile);
	fclose(ofile);
	sprintf(ofilename,"../%s.raw.tfile",de->d_name);
	sprintf(sfilename,"cat geometry.conv gridY dataY gridU dataU gridV dataV > %s",ofilename);
	printf("running: %s\n",sfilename);
	system(sfilename);
	system("rm geometry.conv");//remove the temp file
	printf("done processing directory %s %d of %d\n",de->d_name,i,count);
	i++;
      }
    }
    de=readdir(dir);
  }

  chdir(cwd);

  /*
    concat the header and the conglomerate files, then gzip them and
    output into the yuvofile
  */
  sprintf(objectsToCat,"cat header.convert  %s/*.raw.tfile | gzip -9 -c > %s",
	  argv[1],yuvofile);
  printf("running: %s\n",objectsToCat);
  
  system(objectsToCat);  
  sprintf(objectsToCat,"rm -f %s/*.raw.tfile",argv[1]);
  
  printf("running: %s\n",objectsToCat);
  system(objectsToCat);

  printf("running: rm -f header.convert\n");
  system("rm -f header.convert");
  
  
  free(path);
  return 0;
}
