#include "fileFormat.h"
#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>
#include "mesh.h"
#include "useful.h"
#define DIR_SEP '/'
char cwd[256];


int convertOBJ(FILE * fd,FILE * td,float * mmm)
{
  _3floats * vert;
  _2floats * tvert;
  _3floats * vnorm;
  _3ints  * poly,* tpoly;
  _3floats * pnorm;
  int nvert,ntvert,npoly;
  int i;
  char * line;
  char linebuf[1024];

  nvert = linecount(fd,"v ");
  ntvert = linecount(fd,"vt ");
  npoly  = linecount(fd,"f ");

  nvert=linecount(fd,"v ");
  ntvert=linecount(fd,"vt ");
  npoly=linecount(fd,"f ");

  vert=new _3floats[nvert];
  tvert=new _2floats[ntvert];
  vnorm=new float[nvert][3];
  poly=new _3ints[npoly];
  tpoly=new _3ints[npoly];
  pnorm=new float[npoly][3];

  for(i=0;i<nvert;i++)
  {
    line=nextline(fd,"v ");
    sscanf(line,"v %f %f %f",vert[i],vert[i]+1,vert[i]+2);
  }
  
  fseek(fd,0,SEEK_SET);
  
  for(i=0;i<ntvert;i++)
  {
    line=nextline(fd,"vt ");
    sscanf(line,"vt %f %f",tvert[i],tvert[i]+1);
  }

  fseek(fd,0,SEEK_SET);

  for(i=0;i<npoly;i++)
  {
    line=nextline(fd,"f ");
    sscanf(line,"f %d %d %d",poly[i],poly[i]+1,poly[i]+2);
    poly[i][0]--;
    poly[i][1]--;
    poly[i][2]--;
  }
  i=0;
  fprintf(td,"%d\n",nvert);
  while(i<nvert){
    fprintf(td,"%f %f %f\n",vert[i][0],vert[i][1],vert[i][2]);
    i++;
  }
  i=0;
  fprintf(td,"%d\n",ntvert);
  while(i<ntvert){
    fprintf(td,"%f %f\n",tvert[i][0],tvert[i][1]);
    i++;
  }
  i=0;
  fprintf(td,"%d\n",npoly);
  while(i<npoly){
    fprintf(td,"%d %d %d\n",poly[i][0],poly[i][1],poly[i][2]);
    i++;
  }
  
  fseek(fd,0,SEEK_SET);
  if(line=nextline(fd,"mean_x "))
    sscanf(line,"mean_x %f %f %f",mmm,mmm+1,mmm+2);
  fseek(fd,0,SEEK_SET);
  if(line=nextline(fd,"min_x "))
    sscanf(line,"min_x %f %f %f",mmm+3,mmm+4,mmm+5);
  fseek(fd,0,SEEK_SET);
  if(line=nextline(fd,"max_x "))
    sscanf(line,"max_x %f %f %f",mmm+6,mmm+7,mmm+8);

  return 1;
}

int main(int argc, char ** argv)
{
  char buffer[256];
  char buffer2[256];
  char * cptr;
  struct stat sbuf;
  int ibuffer[16];
  FILE * ofile;
  if(argc<=1){
    printf("run with ./packcage inputfile outputfile\n");
    return 0;
  }
  getcwd(cwd,256);
  
  if(stat(argv[1],&sbuf)<0 || !S_ISDIR(sbuf.st_mode)){
    printf("%s is not a directory\n",argv[1]);
    exit(1);
  }

  chdir(argv[1]);
  
  getcwd(buffer,256);
  cptr = (char *)strrchr(buffer,DIR_SEP);
  
  if(cptr)
    cptr++;
  else{
    printf("error determining folder name from %s\n",buffer);
    chdir(cwd);
    return 0;
  }

  chdir("..");

  sprintf(buffer2,"%s.iff",cptr);
  if(stat(buffer2,&sbuf)==0){
    printf("error: output file %s already exists\n",buffer2);
    chdir(cwd);
    return 0;
  }

  ofile = fopen(buffer2,"w");
  
  chdir(cptr);//Go back into the directory
  {
    DIR * dir = opendir(".");
    int count=0;
    int i=0;

    struct dirent * de =readdir(dir);
    char ** dirnames;
    while(de){
      if(strstr(de->d_name,"data")
	 && stat(de->d_name,&sbuf)==0
	 && S_ISDIR(sbuf.st_mode))
	count++;
      de = readdir(dir);
    }
    i=0;
    dirnames = (char **)malloc(sizeof(char *)*count);
    rewinddir(dir);
    de=readdir(dir);
    while(de){
      if(strstr(de->d_name,"data")
	 && stat(de->d_name,&sbuf)==0
	 && S_ISDIR(sbuf.st_mode)){
	dirnames[i]=(char *)malloc(sizeof(char)*strlen(de->d_name)+1);
	sprintf(dirnames[i],de->d_name);
	i++;
      }
      de = readdir(dir);
    }
    closedir(dir);
    printf("count is %d\n",count);
    
    fprintf(ofile,"%s",PCAO);
    ibuffer[0]=0;
    ibuffer[1]=count;
    fwrite(ibuffer,4,2,ofile);

    i=0;
    while(i<count){
      char tfilename[256];
      float mmm[9];
      int len=0;
      int waste[16];
      int propy[4];
      int propu[4];
      int propv[4];
      int propgy[4];
      int propgu[4];
      int propgv[4];
      char c;
     
      sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"dataY");
      FILE * tfile = fopen(tfilename,"r");
      fread(propy,4,3,tfile);
      fclose(tfile);
       
      sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"dataU");
      tfile = fopen(tfilename,"r");
      fread(propu,4,3,tfile);
      fclose(tfile);
      
      sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"dataV");
      tfile = fopen(tfilename,"r");
      fread(propv,4,3,tfile);
      fclose(tfile);

      sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"gridY");
      tfile = fopen(tfilename,"r");
      fread(propgy,4,3,tfile);
      fclose(tfile);
       
      sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"gridU");
      tfile = fopen(tfilename,"r");
      fread(propgu,4,3,tfile);
      fclose(tfile);
      
      sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"gridV");
      tfile = fopen(tfilename,"r");
      fread(propgv,4,3,tfile);
      fclose(tfile);

      len = (3*3+3*2+2)*4;
      int three=3;
      fprintf(ofile,"%s",POBJ);
      fwrite(&len,4,1,ofile);
      fwrite(&i,4,1,ofile);//id
      fwrite(&three,4,1,ofile);//Number of basis
      fwrite(propy,4,3,ofile);
      fwrite(propu,4,3,ofile);
      fwrite(propv,4,3,ofile);
      fwrite(propgy,4,2,ofile);
      fwrite(propgu,4,2,ofile);
      fwrite(propgv,4,2,ofile);

      FILE * gfile;
      sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"geometry.obj");
      gfile = fopen(tfilename,"r");
      if(!gfile){
	printf("fatal error: %s does not exist\n",tfilename);
	chdir(cwd);
	exit(0);
      }
      sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"geometry.convert");
      FILE * convgfile = fopen(tfilename,"w");
      convertOBJ(gfile,convgfile,mmm);
      fclose(convgfile);
      fclose(gfile);
      convgfile = fopen(tfilename,"r");
      stat(tfilename,&sbuf);
      len = sbuf.st_size;
      /*
	output the geometry for the file
      */
      
      fprintf(ofile,"%s",GEOA);
      ibuffer[0]=len+4;
      ibuffer[1]=i;
      fwrite(ibuffer,4,2,ofile);
      while((fread(&c,1,1,convgfile))){
	fwrite(&c,1,1,ofile);
      }

      /* output the mean,min and max for the lookup table */
      fprintf(ofile,"%s",LUTR);
      len = sizeof(float)*9 +2*sizeof(int);
      fwrite(&len,4,1,ofile);
      fwrite(&i,4,1,ofile);
      fwrite(&three,4,1,ofile);
      fwrite(mmm,9,sizeof(float),ofile);

      
      sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"dataY");
      stat(tfilename,&sbuf);
      len = sbuf.st_size - 12;
      tfile = fopen(tfilename,"r");

      fread(waste,4,3,tfile);//Get rid of width height 
      
      FILE * tfile2;
      sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"gridY");
      stat(tfilename,&sbuf);
      len = sbuf.st_size  - 12;
      tfile2 = fopen(tfilename,"r");

      fread(waste,4,3,tfile2);

      int basisi=0;
      while(basisi<propy[2]){
	int wrote=0;

	fprintf(ofile,"%s",BAS);
	ibuffer[0]=propy[0]*propy[1]*4+16;
	ibuffer[1]=i;
	ibuffer[2]=0;
	ibuffer[3]=basisi;
	ibuffer[4]=4;//propy[2];
	fwrite(ibuffer,4,5,ofile);
	
	while(wrote<propy[0]*propy[1]*4){
	  fread(&c,1,1,tfile);
	  fwrite(&c,1,1,ofile);
	  wrote++;
	}
	if(basisi==0){
	  fprintf(ofile,"%s",LUT);
	  ibuffer[0]=propgy[0]*propgy[1]*3*4+16;
	  ibuffer[1]=i;
	  ibuffer[2]=0;
	  ibuffer[3]=0;
	  ibuffer[4]=3;
	  fwrite(ibuffer,4,5,ofile);
	  
	  wrote=0;
	  while(wrote<propgy[0]*propgy[1]*12){
	    fread(&c,1,1,tfile2);
	    fwrite(&c,1,1,ofile);
	    wrote++;
	  }
	}
	else{
	  fprintf(ofile,"%s",LUT);
	  ibuffer[0]=propgy[0]*propgy[1]*4*4+16;
	  ibuffer[1]=i;
	  ibuffer[2]=0;
	  ibuffer[3]=basisi-1;
	  ibuffer[4]=4;
	  fwrite(ibuffer,4,5,ofile);
	  
	  wrote=0;
	  while(wrote<propgy[0]*propgy[1]*16){
	    fread(&c,1,1,tfile2);
	    fwrite(&c,1,1,ofile);
	    wrote++;
	  }
	}
	basisi+=4;
      }
      fclose(tfile);
      fclose(tfile2);
      //int basisi=0;
      ///while(basisi<16)
      //{
	int towrite;
	sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"dataU");
	stat(tfilename,&sbuf);
	len = sbuf.st_size-12;
	tfile = fopen(tfilename,"r");
	
	fseek(tfile,12,SEEK_SET);
	
	fprintf(ofile,"%s",BAS);
	ibuffer[0]=len+16;
	ibuffer[1]=i;
	ibuffer[2]=1;
	ibuffer[3]=0;
	ibuffer[4]=propu[2];
	fwrite(ibuffer,4,5,ofile);
	
	towrite=0;
	while(towrite<len){
	  fread(&c,1,1,tfile);
	  fwrite(&c,1,1,ofile);
	  towrite++;
	}
	fclose(tfile);
	
	sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"dataV");
	stat(tfilename,&sbuf);
	len =  sbuf.st_size-12;
	tfile = fopen(tfilename,"r");
	
	fseek(tfile,12,SEEK_SET);
	
	fprintf(ofile,"%s",BAS);
	ibuffer[0]=len+16;
	ibuffer[1]=i;
	ibuffer[2]=2;
	ibuffer[3]=0;
	ibuffer[4]=propv[2];
	fwrite(ibuffer,4,5,ofile);
	
	towrite=0;
	while(towrite<len){
	  fread(&c,1,1,tfile);
	  fwrite(&c,1,1,ofile);
	  towrite++;
	}
	
	fclose(tfile);
	//	basisi+=4;
	// }
      /*
	Now output the look up tables
      
      sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"gridY");
      stat(tfilename,&sbuf);
      len = sbuf.st_size  - 12;
      tfile = fopen(tfilename,"r");

      fread(waste,4,3,tfile);

      fprintf(ofile,"%s",LUT);
      ibuffer[0]=len+16;
      ibuffer[1]=i;
      ibuffer[2]=0;
      ibuffer[3]=0;
      ibuffer[4]=propgy[2];
      fwrite(ibuffer,4,5,ofile);

      while(fread(&c,1,1,tfile)){
	fwrite(&c,1,1,ofile);
      }
      fclose(tfile);
      */
            
	sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"gridU");
	stat(tfilename,&sbuf);
	len = sbuf.st_size - 12;
	tfile = fopen(tfilename,"r");
	
	fseek(tfile,12,SEEK_SET);
	
	fprintf(ofile,"%s",LUT);
	ibuffer[0]=len+16;
	ibuffer[1]=i;
	ibuffer[2]=1;
	ibuffer[3]=0;
	ibuffer[4]=propgu[2];
	fwrite(ibuffer,4,5,ofile);
	
	while(fread(&c,1,1,tfile)){
	  fwrite(&c,1,1,ofile);
	}
	fclose(tfile);
	
	sprintf(tfilename,"%s%c%s",dirnames[i],DIR_SEP,"gridV");
	stat(tfilename,&sbuf);
	len = sbuf.st_size - 12;
	tfile = fopen(tfilename,"r");
	
	fseek(tfile,12,SEEK_SET);
	
	fprintf(ofile,"%s",LUT);
	ibuffer[0]=len+16;
	ibuffer[1]=i;
	ibuffer[2]=2;
	ibuffer[3]=0;
	ibuffer[4]=propgv[2];
	fwrite(ibuffer,4,5,ofile);
	
	while(fread(&c,1,1,tfile)){
	  fwrite(&c,1,1,ofile);
	}
	fclose(tfile);

	fprintf(ofile,"%s",EUA);
	len=9*sizeof(float)+1*sizeof(int);//9 floats for the coefficients, 1 int for the index into the object
	fwrite(&len,4,1,ofile);
	fwrite(&i,4,1,ofile);
	float eul[9];
	memset(eul,0,sizeof(float)*9);
	/*HOUSE*/
	  eul[2]=1;
	eul[4]=-1;
	eul[6]=1;
	
	/*	eul[0]=1;
	eul[4]=-1;
	eul[8]=1;*/
	fwrite(eul,sizeof(float),9,ofile);
	
      i++;
    }
    int len = ftell(ofile);
    len=len-8;
    printf("File size = %d\n",len);
    fseek(ofile,4,SEEK_SET);
    fwrite(&len,4,1,ofile);
    
    

    /*
      Free the memory for the directory names
    */
    i=0;
    while(i<count){
      if(dirnames[i])
	free(dirnames[i]);
      i++;
    }
    free(dirnames);
  }
  fclose(ofile);
}
