#ifndef MESH_H
#define MESH_H
#include<stdio.h>

#include <zlib.h>

typedef float _3floats[3];
typedef float _2floats[2];
typedef int _3ints[3];

class Mesh
{
  public:
    Mesh();
    ~Mesh();
    
    int loadlwo(char *);   // load lightwave object
    int loadlwo(FILE *);   // load lightwave object
    int loadobj(char *);   // load obj object
    int loadobj(FILE *);   // load obj object
    int loadobj_gz(gzFile  ); //load obj from gzip file
    void maketexturecoords(int dims[2],float scales[2]);

    void draw();

    void setRotAxis(float * );

    float pos[3];
    float eul[3];
    float rotAxis[9];
  protected:
    void destroy();
    void compute_normals();
    void compute_pnormals();

    void createlist();     // build display list

    unsigned int tex;      // texture id
    unsigned int list;     // display list id

    int nvert;             // number of vertices
    _3floats *vert;        // vertexes in world coords
    _3floats *vnorm;       // vertex normals

    int ntvert;            // number of texture coordinates
    _2floats *tvert;       // texture coordinates
      
    int npoly;             // number of polys
    _3ints *poly;          // triangles
    _3ints *tpoly;         // texture triangles
    _3floats *pnorm;       // polygon normals
};

#endif
