#ifndef TEXTURE_H
#define TEXTURE_H

#include <GL/gl.h>
#include "useful.h"

struct TextureParameter
{
};

class Texture
{
  public:
    Texture(int twidth,int theight,GLenum mode=GL_MODULATE,GLenum type=GL_RGBA)
    {
      char *emptytex=new char[twidth*theight*4];
      texture_width=twidth;
      texture_height=theight;
      glGenTextures(1,&texture_id);
      glBindTexture(GL_TEXTURE_2D,texture_id);
      inittex(emptytex,twidth,theight,type,mode);
      delete emptytex;
    };
      
    void bind(GLenum unit)
    {
      glActiveTextureARB(unit);
      glBindTexture(GL_TEXTURE_2D,texture_id);
    };
    
    virtual void update(TextureParameter *p)=0;
    virtual int load(char *path)=0;

  protected:
    GLuint texture_id;
    int texture_width;
    int texture_height;
};

#endif
