#ifndef USEFUL_H
#define USEFUL_H

#ifdef _WIN32
#include<windows.h>
#endif

#include<stdio.h>
#include<string.h>
#include<GL/gl.h>
#include<GL/glext.h>
#include <zlib.h>
#include <stdarg.h>

#define FORM 0x464F524D
#define LWOB 0x4C574F42
#define PNTS 0x504E5453
#define POLS 0x504F4C53

#define PRINT_DEBUG 1

void printDebug(char *fmt, ...);
void printerror(char *where);
void inittex(void *data,int w,int h,int type=GL_RGB,int mode=GL_MODULATE);
char *readline(FILE *fp);
int linecount(FILE *fd,char *str);
char *nextline(FILE *fd,char *str);
int swaplong(int a);
short int swapshort(short int a);
float swapfloat(float a);
int writeppm(char *filename,int w,int h,char *data);
int gzGetLine(gzFile gzf,char * buffer, int len);

#ifdef _WIN32

extern PFNGLACTIVETEXTUREARBPROC glActiveTextureARB;
extern PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2fARB;
extern PFNGLMULTITEXCOORD2FVARBPROC glMultiTexCoord2fvARB;

extern PFNGLBLENDEQUATIONPROC glBlendEquation;
extern PFNGLBLENDCOLORPROC glBlendColor;

extern PFNGLCOMBINERPARAMETERFVNVPROC glCombinerParameterfvNV;
extern PFNGLCOMBINERPARAMETERIVNVPROC glCombinerParameterivNV;
extern PFNGLCOMBINERPARAMETERFNVPROC glCombinerParameterfNV;
extern PFNGLCOMBINERPARAMETERINVPROC glCombinerParameteriNV;
extern PFNGLCOMBINERSTAGEPARAMETERFVNVPROC glCombinerStageParameterfvNV;
extern PFNGLCOMBINERINPUTNVPROC glCombinerInputNV;
extern PFNGLCOMBINEROUTPUTNVPROC glCombinerOutputNV;
extern PFNGLFINALCOMBINERINPUTNVPROC glFinalCombinerInputNV;
extern PFNGLGETCOMBINERINPUTPARAMETERFVNVPROC glGetCombinerInputParameterfvNV;
extern PFNGLGETCOMBINERINPUTPARAMETERIVNVPROC glGetCombinerInputParameterivNV;
extern PFNGLGETCOMBINEROUTPUTPARAMETERFVNVPROC glGetCombinerOutputParameterfvNV;
extern PFNGLGETCOMBINEROUTPUTPARAMETERIVNVPROC glGetCombinerOutputParameterivNV;
extern PFNGLGETFINALCOMBINERINPUTPARAMETERFVNVPROC glGetFinalCombinerInputfvNV;
extern PFNGLGETFINALCOMBINERINPUTPARAMETERIVNVPROC glGetFinalCombinerInputivNV;


void initGLext();
#endif

#endif




