#ifndef PCAMESH_H
#define PCAMESH_H

#include"mesh.h"
#include"pca.h"
#include <zlib.h>

/*
  Changes:
  july 16 - NB - I have put the lookup tables into bytes only.
  Any incoming floating point files, will be convertedinto the bytes. 
  This doesnt seem to be causing any problems with the rendering,
  since both the software convert to bytes eventually.
*/

class PcaMesh:public Mesh,public Pca
{
  public:
    PcaMesh();
    ~PcaMesh();
    void destroy();
    int loadDir(char *);
    void updatetexture();
    void updatetexture(float *angles);
    void draw();

//  private:
    int initlut(int channel,int width,int height);
    int loadlut(int channel,int start,int howmany,gzFile f,int usingbytes=0);
    int loadlut(int channel,gzFile  f);
    
    void setup_bluescreen_state_NV17();
    void setup_bluescreen_state_NV20();

    GLuint setup_bluescreen;
    GLuint disable_combiners;

     
    char * lut[3];

    float mean_X[3];
    float min_X[3];
    float max_X[3];
    int lutwidth[3];
    int lutheight[3];

    char * coefficients[3];
};

#endif
