#include"useful.h"
#include<stdio.h>
#include<math.h>
#include<sys/timeb.h>
#include<GL/gl.h>
#include<GL/glut.h>
#include<GL/glext.h>
#include"pcamesh.h"

#include <dirent.h>
#include <sys/stat.h>

#include "fileFormat.h"

#include <GProgressBar.h>
#include <GFileWindow.h>
#include <GWindows.h>
#include <GWindow.h>
#include <GEditBox.h>
#include <GObject.h>
#include <GButton.h>
#include <GScrollBar.h>
#include <GMenu.h>
#include <GComboBox.h>
#include <Socket.h>
#include <gzsocket.h>

int COUNT=0;
GLuint winid;
float *lut[3];
float *coeff[3];
int wwidth=640,wheight=480;
int mousebutton=0;
int mousepos[2];
int freezetex=0;
timeb timeA;
timeb timeB;
int framecount=0;

PcaMesh *pcamesh=NULL;

void shutdown(int error=0);
int stream(char * server, char * rfilename);
int loadDir(char * dirToOpen);
int load(char * path);

class GProgressWindow: public GWindow
{
  static void cancelAction(GObject * g){
    if(g){
      g->defaultAction(g);
      stream("cancel",0);
      g->getParent()->setShowing(0);
    }
  }
  static void hideAction(GObject * g){
    if(g){
      g->defaultAction(g);
     g->getParent()-> setShowing(0);
    }
  }
  GProgressBar * gpb;
  GStatic * label;
  GStatic * progressLabel;
  GButton * cancel;
  GButton *  hide;
 public:
  GProgressWindow():GWindow(NULL,"Streaming",wwidth-wwidth/2-50,50,140,90){
    gpb = new GProgressBar(this,5,40,130,10,0,100);
    addObject(gpb);
    gpb->setShowing(1);
    
    label = new GStatic(this,"Downloading",5,25,100,TEXT_HEIGHT+2);
    addObject(label);
    
    progressLabel = new GStatic(this,"0 percent complete",5,50,100,TEXT_HEIGHT+2);
    addObject(progressLabel);

    cancel =new GButton(this,"Cancel",80,70,45,TEXT_HEIGHT+4);
    addObject(cancel);

    hide = new GButton(this,"Hide",15,70,45,TEXT_HEIGHT+4);
    addObject(hide);
    
    cancel->action = GProgressWindow::cancelAction;
    hide->action = GProgressWindow::hideAction;
  }
  void setLabelText(char * text){
    label->setText(text);
  }
  void updateProgress(int progress,int outof){
    int max = gpb->getMax();
    int min = gpb->getMin();
    int range = max-min;
    float ratio = (float)progress/(float)outof;
    
    char str[64];
    sprintf(str,"%d percent complete",(int)(ratio*100.0f));
    progressLabel->setText(str);
    
    ratio = ratio*range;
    gpb->setValue((int)ratio);
        
  }
};

/*
  This is the information window class.  It simply displays
  some simple information
*/
class GInfoWindow: public GWindow
{
 private:
  GStatic * fpsLabel;
  GStatic * rendererLabel;
  GStatic * vendorLabbel;
  GButton * close;
  
 public:
  GInfoWindow():GWindow(NULL,"Info",wwidth-250,0,250,160){
    char str[256];
    addObject(new GGroupBox(this,"Display Information",5,25,240,100));
    
    sprintf(str,"Vendor:%s",glGetString(GL_VENDOR));
    addObject(new GStatic(this,str,6,35,140,TEXT_HEIGHT+2));

    sprintf(str,"Renderer:%s",glGetString(GL_RENDERER));
    addObject(new GStatic(this,str,6,50,140,TEXT_HEIGHT+2));

    sprintf(str,"Hardware supported: %s",
	    (Pca::getHardwareSupported())?"Yes":"No");
    addObject(new GStatic(this,str,6,65,140,TEXT_HEIGHT+2));
    
    close = new GButton(this,"Close",10,135,35,15);
    fpsLabel = new GStatic(this,"fps:",6,90,35,15);
    
    close->action = closeButton->action;
    
    addObject(close);
    addObject(fpsLabel);
  }
  virtual void setShowing(int i){
    GWindow::setShowing(i);
  }
  GObject *  getFPSLabel(){
    return fpsLabel;
  }    
};

GProgressWindow * progressWindow;
GInfoWindow * gwinfoWindow;
GWindow * gwoptionsWindow;
GWindow * gwhelpWindow;
GMenuItem * optionsmi;
GMenuItem * helpmi;
GMenuItem * exitmi;
GMenuItem * openmi;
GRadioButton *hardwarerb,*softwarerb;
GRadioButton *mmxrb;
GMenu * menu;

int reload();

void rbaction(GObject * go)
{
  if(go){
    if(go==mmxrb){
      
    }
    else{
      hardwarerb->setValue(0);
      softwarerb->setValue(0);
    }
    ((GRadioButton *) go)->defaultAction(go);
    if(hardwarerb==go){
      mmxrb->setActive(0);
      if(pcamesh){
	/*for(int i=0;i<COUNT;i++)
	pcamesh[i].setUsingHardware(1);*/
	reload();
      }
    }
    else if(softwarerb==go){
      mmxrb->setActive(1);
      if(pcamesh){
	/*for(int i=0;i<COUNT;i++)
	  pcamesh[i].setUsingHardware(0);*/
	reload();
      }
      
      if(pcamesh){
	mmxrb->setValue(pcamesh[0].getUsingMMX());
      }
    }
    else if(mmxrb==go){
      if(pcamesh)
	for(int i=0;i<COUNT;i++)
	  pcamesh[i].setUsingMMX(mmxrb->getValue());
    }
  }
}

void freezeCallback(GObject * go){
  if(go){
    go->defaultAction(go);
    freezetex=((GRadioButton * )go)->getValue();
  }
}
void basisCallback(GObject * go){
  if(go){
    float f = ((GSpinEditBox *)go)->getValue();
    if(pcamesh)
      for(int i=0;i<COUNT;i++)
	pcamesh[i].setQuality(f/100.0f);
    printDebug("Setting quality\n");
  }
}

void sizeComboAction(GObject * go){
  if(go){
    char str[32];
    int rf=1;
    printDebug("Size combo action\n");
    go->defaultAction(go);
    go->getText(str,32);
    if(strcmp(str,"High")==0){
      rf=1;
    }
    else if(strcmp(str,"Medium")==0){
      rf=2;
    }
    else if(strcmp(str,"Low")==0){
      rf=3;
    }

    if(pcamesh){
      for(int i=0;i<COUNT;i++){
	pcamesh[i].setReduceFactor(rf);
      }
    }
  }
}

class GOptionsWindow : public GWindow
{
 private:
  GSpinEditBox * basisEdit;
  GComboBox    * sizeCombo;
  GRadioButton * freeze; 
  public:
  GOptionsWindow():GWindow(NULL,"options",wwidth-195,160,195,170){
    hardwarerb = new GRadioButton(gwoptionsWindow,"Hardware",10,40,40,15);
    hardwarerb->action = rbaction;
    softwarerb = new GRadioButton(gwoptionsWindow,"Software",10,55,40,15);
    softwarerb->action = rbaction;
    mmxrb = new GRadioButton(this,"MMX",30,70,40,15);
    mmxrb->action = rbaction;

    this->addObject(new GGroupBox(this,"Rendering Mode",5,25,80,80));
    this->addObject(hardwarerb);
    this->addObject(softwarerb);
  
    this->addObject(mmxrb);
    this->addObject(new GGroupBox(this,"Quality:",90,25,100,80));
    this->addObject(new GStatic(this,"Basis Ratio:",93,40,40,16));
    
    freeze = new GRadioButton(this,"Freeze Texture",10,120,60,15);
    freeze->action = freezeCallback;
    this->addObject(new GGroupBox(this,"General options",5,110,185,50));
    this->addObject(freeze);
    
    basisEdit = new GSpinEditBox(G_NUMBERSONLY,this,100,150,40,40,16);
    basisEdit->setMin(10);
    basisEdit->setMax(100);
    basisEdit->setDisplayAsInt(1);
    basisEdit->setIncrement(10);
    basisEdit->action = basisCallback;
    this->addObject(basisEdit);
    
    this->addObject(new GStatic(this,"Texture res:",93,65,40,16));
    sizeCombo = new GComboBox(0,this,150,65,40,16,50);
    sizeCombo->addElement("High");
    sizeCombo->addElement("Medium");
    sizeCombo->addElement("Low");
    sizeCombo->action = sizeComboAction;
    this->addObject(sizeCombo);
  }
  
  void setShowing(int i){
    GWindow::setShowing(i);

    if(i){
      int mode=0;
      int r=1;
      int quality=100;

      printDebug("about to %p\n",pcamesh);
      if(pcamesh){
	mode=pcamesh[0].getUsingHardware();
	r=pcamesh[0].getReduceFactor();
	quality = (int)(pcamesh[0].getQuality()*100);
      }
      hardwarerb->setValue(mode);
      softwarerb->setValue(!mode);

      if(!Pca::getHardwareSupported()){
	hardwarerb->setActive(0);
      }
      if(!mode){
	if(pcamesh)
	  mmxrb->setValue(pcamesh[0].getUsingMMX());
      }
      quality = quality-quality%10;
      r--;
      if(r>=3)
	r=2;
      sizeCombo->setSelected(r);
      basisEdit->setValue(quality);
      freeze->setValue(freezetex);
    }
  }
};

void openFileCallback(int value, char * path)
{
  if(value){
    if(path){
      load(path);
    }
  }
  if(path)
    delete [] path;
}

void openFileWindow(GObject * go)
{
  GFileWindow * gfw = (GFileWindow *)gwAddFileOpenWindow();
  if(gfw){
    gfw->setXPosition(100);
    gfw->setYPosition(100);
    gfw->fileWindowCallback=openFileCallback;
  }
}

void optionsWindow(GObject * go)
{
  if(go){
    gwoptionsWindow->setShowing(1);
  }
}
void infoWindow(GObject * go)
{
  if(go){
    gwinfoWindow->setShowing(1);
  }
}
void helpWindow(GObject * go)
{
  if(go){
    gwhelpWindow->setShowing(1);
  }
}
void exitAction(GObject * go)
{
  shutdown();
}

void demo2()
{
  GMenuItem * infomi;
  menu = new GMenu(MENU_VERTICAL | MENU_POPUP,NULL,"Main Menu",10,10,70,15);
  optionsmi = new GMenuItem(menu,"Options",0,0,0,0);
  openmi = new GMenuItem(menu,"Open",0,0,0,0);
  helpmi = new GMenuItem(menu,"Help",0,0,0,0);
  exitmi = new GMenuItem(menu,"Exit",0,0,0,0);
  infomi = new GMenuItem(menu,"Info",0,0,0,0);
  

  optionsmi->action = optionsWindow;
  openmi->action = openFileWindow;
  helpmi->action = helpWindow;
  infomi->action = infoWindow;
  exitmi->action = exitAction;

  gwAddObject(menu);
  menu->addMenuItem(new GMenuItem(menu,"",0,0,0,0));
  menu->addMenuItem(openmi);
  menu->addMenuItem(infomi);
  menu->addMenuItem(optionsmi);
  menu->addMenuItem(new GMenuItem(menu,"",0,0,0,0));
  menu->addMenuItem(helpmi);
  menu->addMenuItem(exitmi);
  
  gwoptionsWindow = new GOptionsWindow();
  gwhelpWindow = new GWindow(NULL,"help",120,120,400,400);
  gwinfoWindow = new GInfoWindow();

  gwAddObject(gwoptionsWindow);
  gwAddObject(gwhelpWindow);
  gwAddObject(gwinfoWindow);

  menu->setShowing(0);
  gwhelpWindow->setShowing(0);
  gwoptionsWindow->setShowing(0);

  progressWindow = new GProgressWindow();
  gwAddObject(progressWindow);
}

struct KeyFrame
{
  float eul[3];
  KeyFrame *next;
} *keyframes=NULL;

#define NORMALDISP
void display()
{
  int count=40;
#ifdef NORMALDISP  
  if(++framecount==count)
    {
      int ms_diff;
      ftime(&timeB);
      ms_diff=1000*(timeB.time-timeA.time)+timeB.millitm-timeA.millitm;
      //printf("%f fps\n",(float)count/(float(ms_diff)/1000));
      timeA=timeB;
      framecount=0;
      if(gwinfoWindow->isShowing()){
	char fps[32];
	sprintf(fps,"fps: %f",(float)count/(float(ms_diff)/1000));
	gwinfoWindow->getFPSLabel()->setText(fps);
      }
    }
  		
  glDisable(GL_DEPTH_TEST);

  int which=0;
  float dif=10000;
  for(int i=0;i<COUNT;i++)
  {
    if(fabs(pcamesh[i].eul[1]-pcamesh[i].mean_X[1])<dif)
    {
      dif=fabs(pcamesh[i].eul[1]-pcamesh[i].mean_X[1]);
      which=i;
    }
  }

  //if(COUNT!=0){
  // if(!freezetex)
  //   pcamesh[which].updatetexture();
  //}
  
  if(!freezetex)
    for(int i=0;i<COUNT;i++) pcamesh[i].updatetexture();
  
  glClearColor(0.23,0.46,0.74,1);
  glClear(GL_DEPTH_BUFFER_BIT|GL_COLOR_BUFFER_BIT);

  /* The hardware version needs blending */
  if(Pca::getHardwareSupported()){
    glEnable(GL_BLEND); 
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
    glBlendEquation(GL_FUNC_ADD);
  }
  //bluescreen color:
  glColor3f(1,1,1);
   
  glEnable(GL_DEPTH_TEST);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  
  //if(COUNT)
  //  pcamesh[which].draw();
  for(int i=0;i<COUNT;i++) pcamesh[i].draw();

  glPopMatrix();

  glDisable(GL_BLEND);
  glDisable(GL_TEXTURE_2D);
  glDisable(GL_DEPTH_TEST);

  gwDisplay(wwidth,wheight);
  
  glEnable(GL_BLEND);
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_DEPTH_TEST);

#endif
  glutSwapBuffers();

  stream(0,0);
  
  printerror("display");
}

void mouse(int x,int y)
{
  if(!mousebutton)
    gwMouseMoved(x,y);
  if(mousebutton)
  {
    if(!gwMouseDragged(x,y)){
      if(mousebutton==1){
	int xind,yind,channel;
	
	for(int i=0;i<COUNT;i++)
	  {
	    pcamesh[i].eul[1]=pcamesh[i].eul[1]-((float)(x-mousepos[0]))/5;
	    pcamesh[i].eul[2]=pcamesh[i].eul[2]-((float)(y-mousepos[1]))/15;
	  }
      }
      else{
	//      pos[0]+=((float)(y-mousepos[1])/50)*sin(-rot[2]*M_PI/180);
	//      pos[2]+=((float)(y-mousepos[1])/50)*cos(-rot[2]);
	
	for(int i=0;i<COUNT;i++)
	  {
	    pcamesh[i].pos[2]=pcamesh[i].pos[2]-(float)(y-mousepos[1])/100;
	    pcamesh[i].pos[0]=pcamesh[i].pos[0]-(float)(x-mousepos[0])/100;
	  }
      }
    }
    glutPostRedisplay();
    
  }
  mousepos[0]=x;
  mousepos[1]=y;
}

void clicks(int button,int state,int x,int y)
{
  if(state==GLUT_DOWN){
    gwMousePressed(button,x,y);
    mousebutton=button+1;
  }
  else {
    gwMouseReleased(button,x,y);
    mousebutton=0;
  }
}

void keys(unsigned char key,int,int)
{
  int i;

  switch(key)
  {
  case '~':
  case '`':
    menu->setShowing(!menu->getShowing());
    break;
  case '1':
    pcamesh[0].setReduceFactor(1);
    break;
  case '2':
    pcamesh[0].setReduceFactor(2);
    break;
  case '3':
    pcamesh[0].setReduceFactor(3);
    break;
  case '4':
    pcamesh[0].setReduceFactor(4);
    break; 
  case '+':
    for(int i=0;i<COUNT;i++)pcamesh[i].setQuality(pcamesh[0].getQuality()+0.1);break;
  case '-':
    for(int i=0;i<COUNT;i++)pcamesh[i].setQuality(pcamesh[0].getQuality()-0.1);break;
    case 'f':freezetex=(freezetex+1)%2;break;

    case 'k':
     {
	     KeyFrame** kf=&keyframes;
	     while(*kf)kf=&((*kf)->next);
	     *kf=new KeyFrame;
	     (*kf)->next=NULL;
	     for(int i=0;i<3;i++)(*kf)->eul[i]=pcamesh[0].eul[i];
	     break;
     }
    case 'l':
     {
	     KeyFrame** kf=&keyframes;
	     if(!*kf)break;
	     while((*kf)->next)kf=&((*kf)->next);
	     delete *kf;
	     *kf=NULL;
	     break;
     }


#define NINTERP 10
    case ' ':
     {
       int i,j,framecount=0;
       char filename[256];
       float oldeul[3];
       char *data=new char[wwidth*wheight*3];
       KeyFrame *kf=keyframes;
       if(!kf)break;
       for(i=0;i<3;i++)pcamesh[0].eul[i]=kf->eul[i];
       kf=kf->next;
       while(kf)
       {
	 for(i=0;i<3;i++)oldeul[i]=pcamesh[0].eul[i];

	 for(j=0;j<NINTERP+1;j++)
	 {
	   for(i=0;i<3;i++)pcamesh[0].eul[i]=((NINTERP-j)*oldeul[i]+(j)*kf->eul[i])/NINTERP;
	   display();
	   sprintf(filename,"/usr/scratch/keith/frames/frame%.4d.ppm",framecount++);

       glReadBuffer(GL_FRONT);
       glReadPixels(0,0,wwidth,wheight,GL_RGB,GL_UNSIGNED_BYTE,data);
       glReadBuffer(GL_BACK);

           writeppm(filename,wwidth,wheight,data);

	 }
	 kf=kf->next;
       }
       delete data;
       break;
     }
	     
  }
  /*
  for(i=0;i<3;i++)
  {
    for(int j=0;j<COUNT;j++)
    {
      if(pcamesh[j].nruse[i]<0)pcamesh->nruse[i]=0;
      if(pcamesh[j].nruse[i]>pcamesh->nreig[i])pcamesh->nruse[i]=pcamesh->nreig[i];
    }
    }*/
  glutPostRedisplay();
}

void postRedisplay()
{
  glutPostRedisplay();
}

void reshape(int w,int h)
{
  wwidth=w;
  wheight=h;
  glViewport(0,0,w,h);
}

/*
  pre: the two arguments are valid 4 byte tags
  post: a comparison is done to see if the two
  tags are equal.  Return 1 if they are, 0 otherwise
*/
int tagequal(char * tag,char * src)
{
  if(tag[0]==src[0]
     && tag[1]==src[1]
     && tag[2]==src[2]
     && tag[3]==src[3])
    return 1;
  return 0;
}

/*
  pre: buffer is the tag, len is the length of the block
  post: Process the given tag in buffer if possible, otherwise
        ignore and skip len bytes in gzFile f.

  NOTE: please see the documentation in lib/fileFormat.html for more information
  on the file format.
*/
int processTag(gzFile f,char * buffer,int len)
{
  if(tagequal(buffer,POBJ)){
    int id;
    int j;
    int whn[3];
    int nrchannel;
    
    gzread(f,&id,4);
    gzread(f,&nrchannel,4);
    printDebug("got pobj len=%d id=%d %d\n",len,id,nrchannel);
    j=0;
    while(j<nrchannel){
      gzread(f,whn,12);
      printDebug("channel %d w=%d h=%d nb=%d\n",j,whn[0],whn[1],whn[2]);
      pcamesh[id].initBasis(j,whn[0],whn[1],whn[2]);
      printDebug("channel %d inited\n",j);
      j++;
    }
    printDebug("Done initing basis\n");
    j=0;
    while(j<nrchannel){
      gzread(f,whn,8);
      printDebug("channel %d w=%d h=%d\n",j,whn[0],whn[1]);
      pcamesh[id].initlut(j,whn[0],whn[1]);
      j++;
    }
    printDebug("inited\n");
  }
  else if(tagequal(buffer,BAS)){
    printDebug("got bas %d\n",len);
    int which;
    int channel;
    int start;
    int howmany;
    int where = gztell(f);
    
    gzread(f,&which,4);
    gzread(f,&channel,4);
    gzread(f,&start,4);
    gzread(f,&howmany,4);
    
    printDebug("loading basis %d %d %d %d\n",which,channel,start,howmany);
    pcamesh[which].loadbasis(channel,start,howmany,f);
    printDebug("should be %d, is %d\n",where+len,gztell(f));    
  }
  else if(tagequal(buffer,LUT)){
    printDebug("got lut\n");
    int which;
    int channel;
    int start;
    int howmany;
    gzread(f,&which,4);
    gzread(f,&channel,4);
    gzread(f,&start,4);
    gzread(f,&howmany,4);
    printDebug("loading lut len=%d %d %d %d %d\n",len,which,channel,start,howmany);
    pcamesh[which].loadlut(channel,start,howmany,f);
  }
  else if(tagequal(buffer,LUTB)){
    printDebug("got lutb\n");
    int which;
    int channel;
    int start;
    int howmany;
    
    gzread(f,&which,4);
    gzread(f,&channel,4);
    gzread(f,&start,4);
    gzread(f,&howmany,4);

    printDebug("loading lut len=%d %d %d %d %d\n",len,which,channel,start,howmany);
    
    pcamesh[which].loadlut(channel,start,howmany,f,1);//its using bytes, so pass the byte flag
  }
  else if(tagequal(buffer,GEOA)){
    printDebug("got geoa %d, len=%d\n",gztell(f),len);
    char line[256];
    int which;
    
    gzread(f,&which,4);
    pcamesh[which].loadobj_gz(f);
  }
  else if(tagequal(buffer,LUTR)){
    int howmany;
    int i=0;
    int id=0;
    gzread(f,&id,4);
    gzread(f,&howmany,4);
    
    printDebug("got lutr id=%d howmany=%d\n",id,howmany);
    
    gzread(f,pcamesh[id].mean_X,howmany*sizeof(float));
    gzread(f,pcamesh[id].min_X,howmany*sizeof(float));
    gzread(f,pcamesh[id].max_X,howmany*sizeof(float));
  }
  else if(tagequal(buffer,EUA)){
    int id=0;
    float eua[9];
    gzread(f,&id,4);
    gzread(f,eua,9*sizeof(float));
    
    pcamesh[id].setRotAxis(eua);
   
  }
  else {
    buffer[4]=0;
    printDebug("Got unknown tag =%s\n",buffer);
    printDebug("with len = %d\n",len);
    gzseek(f,len,SEEK_CUR);
    return 1;
  }
  return 0;
}

/*
  post: load a file in the new file format
*/
int loadYuv(char * path)
{
  int i=0;
  int newCount=0;
  int len=0;
  int nread=0;
  int hardware=0;
  char buffer[256];
  char progress[]="|/-\\";
  int pi=0;
  gzFile f = gzopen(path,"rb");
  if(!f)
    return 0;
  gzread(f,buffer,4);
  if(!tagequal(buffer,PCAO)){
    return 0;
  }
  gzread(f,&len,4);
  gzread(f,&COUNT,4);
  printDebug("count %d,len %d\n",COUNT,len);

  if(pcamesh){
    delete [] pcamesh; 
  }
  hardware = Pca::getHardwareSupported() && hardwarerb->getValue();
  
  pcamesh = new PcaMesh[COUNT];
  while(i<COUNT){
    pcamesh[i].setUsingHardware(hardware);
    i++;
  }
  nread=gzread(f,buffer,4);
  while(nread>0){
    gzread(f,&len,4);
    processTag(f,buffer,len);
    nread=gzread(f,buffer,4);
    
    putchar(progress[pi>>3]);
    putchar('\r');
    pi = (pi+1)%32;
    fflush(stdout);
  }
  gzclose(f);
  return 1;
}

/*
  post: load a directory in the older format
*/
int loadDir(char * path)
{
  int i=0;
  int hardware=0;
  char * dirToOpen;
  printDebug("dir to open is <%s>\n",path);
  if(!path)
    return 0;
  int len = strlen(path);
  char * end = path+len-1;
  dirToOpen = (char *)malloc(strlen(path)+2);
  if(strrchr(path,DIR_SEPARATOR)!=path+len-1){
    sprintf(dirToOpen,"%s%c",path,DIR_SEPARATOR);
  }
  else sprintf(dirToOpen,"%s",path);
  printDebug("dir to open is now <%s>\n",dirToOpen);

  DIR * dir= opendir(dirToOpen);
  if(!dir){
    free(dirToOpen);
    return 0;
  }
  struct dirent * de;
  COUNT=0;
  de=readdir(dir);
  while(de){
    if(strstr(de->d_name,"data")){
      printDebug(">%s %d\n",de->d_name,COUNT);
      COUNT++;
    }
    de = readdir(dir);
  }
  closedir(dir);

  if(pcamesh){
    delete [] pcamesh;
    pcamesh=NULL;
  }
  
  hardware = Pca::getHardwareSupported() && hardwarerb->getValue();

  if(COUNT==0){
    free(dirToOpen);
      return 0;
  }
  dir=opendir(dirToOpen);
  pcamesh = new PcaMesh[COUNT];
  i=0;
  while(i<COUNT){
   pcamesh[i].setUsingHardware(hardware);
    i++;
  }
  char * s;
  for(i=0;i<COUNT;i++){
    pcamesh[i].pos[0]=0;
    pcamesh[i].pos[2]=0;
    de=readdir(dir);
    while(de){
      if(strstr(de->d_name,"data")){
	break;
      }
      de=readdir(dir);
    }
    if(de){
      char buffer[256];
      sprintf(buffer,"%s%s",dirToOpen,de->d_name);
      pcamesh[i].loadDir(buffer);      
    }else break;
  }
  closedir(dir);
  free(dirToOpen);
  if(i!=COUNT || COUNT==0){
    printDebug("error reading in the data files, got %d of %d\n",i,COUNT);
    return 0;
  }
  return 1;
}
char currentlyLoaded[1024];
int reload()
{
  printDebug("in reload %s\n",currentlyLoaded);
  return load(currentlyLoaded);
}

/*
  int load(char * path)
  post: attempt to load the path, whether it be a link, a gzipped or non-zipped
  file or directory
*/
int load(char * path)
{
  struct stat buf;
  int ret=0;

  printDebug("in load >%s\n",path);
  if(stat(path,&buf)<0){
    char server[255];
    char file[255];
    char buffer[255];
   
    char * doubleslash=strstr(path,"//");
    if(!doubleslash){
      fprintf(stderr,"Error reading link.  Link does not contain \"http://\"\n");
      file[0]=0;
      server[0]=0;
    }
    else{
      sprintf(server,doubleslash+2);
      sprintf(file,path);
      char * singleslash = strchr(doubleslash+2,'/');
      if(!singleslash){
	fprintf(stderr,"Link does not contain a file.  Cannot open root directory\n");
	server[0]=0;
	file[0]=0;
      }
      else
	server[singleslash-doubleslash-2]=0;
      if(server[0] && file[0]){
	stream(server,file);
	return 1;
      }
    }
    return 0;
  }
  else if(S_ISDIR(buf.st_mode)){
    ret=loadDir(path);
  }
  else{
    ret=loadYuv(path);
    if(!ret){
      char link[1024];
      FILE * file =fopen(path,"r");
      fgets(link,1024,file);
      ret=load(link);
    }
    if(!ret){
      char string[512];
      sprintf(string,"file : %s is not valid.",path);
      gwAddMessageBox(0,"Error Loading File",string);
    }
  }
  if(ret)
    sprintf(currentlyLoaded,path);
  return ret;
}

int filesize=10;
int stream(char * server, char * rfilename)
{
  static Socket s;
  static int readSoFar=0;
  static int recvSoFar=0;
  static FILE * localfile;
  static char  localfilename[256];
  static gzSocket gzsocket;
  static gzFile   readfile;
  static int inited=0;
  static int need=0;
  static char tagbuff[16];
  static int len=0;
  
  if(server&&strcmp(server,"cancel")==0){
    inited=0;
  }
  else if(server&&rfilename){
    printDebug("attempting to connecting %s\n",server);
    if(!s.connect(server,80)){
      inited=0;
      return 0;
    }
    printDebug("connected to %s\n",server);
    s.send("GET ",4);
    s.send(rfilename,strlen(rfilename));
    s.send("\r\n",3);
    recvSoFar=0;

    
    gzsocket = gzsockopen(s.getSock(),"rb");
    if(!gzsocket)
      shutdown(1);
    
    sprintf(localfilename,"%s/yuv-XXXXXX",P_tmpdir);
    mkstemp(localfilename);

    printDebug("temp file is %s\n",localfilename);

    localfile = fopen(localfilename,"wb");

    if(!localfile){
      inited=0;
      return 0;
    }
    recvSoFar=0;
    readSoFar=0;
    inited=1;
    
    progressWindow->setShowing(1);
  }
  else if(inited){
    char buffer[2048];
    int i=0;
    int recv=0;
    
    if(!readSoFar){
      // streamWaitFor(&s,localfile,12,&recv);

      gzsockread(gzsocket,buffer,12);
      fwrite(buffer,12,1,localfile);
      fflush(localfile);
      
      readfile = gzopen(localfilename,"rb");
      gzread(readfile,buffer,4);
      
      if(!tagequal(buffer,PCAO)){
	fprintf(stderr,"not valid yiff file\n");
	fprintf(stderr,"buffer = %s\n",buffer);
	inited=0;
	progressWindow->setShowing(0);
	gwAddMessageBox(0,"Error","File is not a valid yiff file.  Please check that the link is correct.");
	return 0;
      }
      gzread(readfile,&len,4);
      gzread(readfile,&COUNT,4);
      printDebug("count %d,len %d\n",COUNT,len);

      filesize=len;
     
      readSoFar=12;
      recvSoFar=12;
      if(pcamesh)
	delete [] pcamesh;
      pcamesh = new PcaMesh[COUNT];
    }

    /*
      For this frame, let the socket read as much as
      possible without blocking
    */
    while(i<60){
      if(s.ready()){
	recv = gzsockread(gzsocket,buffer,2048);
	if(recv<=0){
	  //  printf("Received file\n");
	}
	else{
	  fwrite(buffer,recv,1,localfile);
	  fflush(localfile);
	  recvSoFar+=recv;
	}
      }
      i++;
    }
    
    progressWindow->updateProgress(recvSoFar,filesize);

    if(!need){
      if(gzread(readfile,tagbuff,4)<=0){
	progressWindow->setShowing(0);
	inited=0;
	sprintf(currentlyLoaded,localfilename);
	return 0;
      }
      if(gzread(readfile,&len,4)<=0){
	inited=0;
	return 0;
      }
      readSoFar+=8;
      need=len+readSoFar;
    }

    if(recvSoFar<need){
      //printf("waiting\n");
      return 0;
    }
    processTag(readfile,tagbuff,len);
    printDebug("after pt\n");
    /*OLD Load
    if(tagequal(tagbuff,POBJ)){
      int id;
      int j;
      int whn[3];
      int nrchannel;
      
      gzread(readfile,&id,4);
      gzread(readfile,&nrchannel,4);
      
      printf("got pobj len=%d id=%d %d\n",len,id,nrchannel);
      j=0;
      while(j<nrchannel){
	gzread(readfile,whn,12);
	printf("channel %d w=%d h=%d nb=%d\n",j,whn[0],whn[1],whn[2]);
	pcamesh[id].initBasis(j,whn[0],whn[1],whn[2]);
	printf("channel %d inited\n",j);
	j++;
      }
      printf("Done initing basis\n");
      j=0;
      while(j<nrchannel){
	gzread(readfile,whn,8);
	printf("channel %d w=%d h=%d\n",j,whn[0],whn[1]);
	pcamesh[id].initlut(j,whn[0],whn[1]);
	j++;
      }
      printf("inited\n");
    }
    else if(tagequal(tagbuff,BAS)){
      printf("got bas %d\n",len);
      int which;
      int channel;
      int start;
      int howmany;
      
      gzread(readfile,&which,4);
      gzread(readfile,&channel,4);
      gzread(readfile,&start,4);
      gzread(readfile,&howmany,4);
      //int before = gztell(readfile);
      pcamesh[which].loadbasis(channel,start,howmany,readfile);
      //      printf("done loading basis %d %d %d %d\n",which,channel,start,howmany);
      //  printf("len was %d %d %d\n",gztell(readfile),before,gztell(readfile)-before);
    }
    else if(tagequal(tagbuff,LUT)){
      printf("got lut\n");
      int which;
      int channel;
      int start;
      int howmany;
      gzread(readfile,&which,4);
      gzread(readfile,&channel,4);
      gzread(readfile,&start,4);
      gzread(readfile,&howmany,4);
      printf("loading lut len=%d %d %d %d %d\n",len,which,channel,start,howmany);
      pcamesh[which].loadlut(channel,start,howmany,readfile);
    }
    else if(tagequal(tagbuff,GEOA)){
      // printf("got geoa readSoFar=%d,%d recv=%d len=%d\n",readSoFar,gztell(readfile),recvSoFar,len);
      int which;
      gzread(readfile,&which,4);
      pcamesh[which].loadobj_gz(readfile);
    }
    else if(tagequal(tagbuff,LUTR)){
      int howmany;
      int i=0;
      int id=0;
      gzread(readfile,&id,4);
      gzread(readfile,&howmany,4);
      
      printf("got lutr id=%d howmany=%d\n",id,howmany);
      
      gzread(readfile,pcamesh[id].mean_X,howmany*sizeof(float));
      gzread(readfile,pcamesh[id].min_X,howmany*sizeof(float));
      gzread(readfile,pcamesh[id].max_X,howmany*sizeof(float));
    }
    else {
      buffer[4]=0;
      printf("nothing =%s %d\n",buffer,len);
      inited=0;
      //printf("nothing len = %d\n",len);	
    }
    */
    readSoFar=need;
    need=0;
  }
}

int main(int ac,char **av)
{
  char *emptytex;
  int i,j;
  float mat[]={1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1};
  glutInit(&ac, av);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);// | GLUT_ALPHA);
  glutInitWindowSize(wwidth,wheight);
  winid=glutCreateWindow("demo");
  glutDisplayFunc(display);
  glutIdleFunc(postRedisplay);
  glutMotionFunc(mouse);
  glutPassiveMotionFunc(mouse);
  glutMouseFunc(clicks);
  
  glutKeyboardFunc(keys);
  glutReshapeFunc(reshape);
  glEnable(GL_DEPTH_TEST);
  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);


  glMatrixMode(GL_PROJECTION);
  gluPerspective(-52,-4.0/3.0,1,1000);
//  glOrtho(-2,2,-2,2,-100,100);
  glMultMatrixf(mat);
  glMatrixMode(GL_MODELVIEW);
  glTranslatef(0,0,-5);
  
  gwInit();
  demo2();

#ifdef _WIN32
  initGLext();
#endif
  
  char dirToOpen[256];
  if(ac>1)
    sprintf(dirToOpen,"%s",av[1]);
  else
    sprintf(dirToOpen,".%c",DIR_SEPARATOR);
  pcamesh=NULL;
  load(dirToOpen);
  if(0)
  {
    char server[255];
    char file[255];
    char buffer[255];
    if(ac>1){
      char * doubleslash=strstr(av[1],"//");
      if(!doubleslash){
	fprintf(stderr,"Error reading link.  Link does not contain \"http://\"\n");
	file[0]=0;
	server[0]=0;
      }
      else{
	sprintf(server,doubleslash+2);
	sprintf(file,av[1]);
	char * singleslash = strchr(doubleslash+2,'/');
	if(!singleslash){
	  fprintf(stderr,"Link does not contain a file.  Cannot open root directory\n");
	  server[0]=0;
	  file[0]=0;
	}
	else
	  server[singleslash-doubleslash-2]=0;
      
      }
    }
    //sprintf(server,"www.cs.ualberta.ca");
    //sprintf(file,"http://www.cs.ualberta.ca/~birkbeck/house.iff2.gz");
    if(server[0] && file[0]){
      stream(server,file);
    }
  }
  
  //load("house.iff");
  //  return 0;
  ftime(&timeA);

  glutMainLoop();
  return 0;
}

void shutdown(int errorCode)
{
  int i=0;
  printDebug("shutting down\n");
  gwShutdown();
  printDebug("gwShutdown complete\n");

  if(pcamesh){
    delete [] pcamesh;
  }
  printDebug("Done shutting down\n");
  exit(errorCode);
}


